# Stadium Protocol eXtension

Протокол поддерживает различного рода расширения и надстройки, которые могут использоваться в совместимой между собой манере. Под совместимостью подразумевается, что:

- все корректные пакеты, отправленные узлом без расширения узлу с расширением, будут корректно разобраны и интерпретированы;
- все корректные для базового протокола пакеты, отправленные узлом с расширением узлу без расширения, будут корректно разобраны и интерпретированы;
- расширения не используют конфликтующие элементы функциональности;
- в рамках одной сессии может быть использована любая произвольная комбинация расширений.

У каждого расширения есть свой уникальный идентификатор/-ы (SPXI) и дескриптор/-ы (SPXD). Идентификатор является либо целым семибитным числом без знака, либо строкой в кодировке ASCII, оканчивающейся нулевым байтом, либо целым числом без знака произвольного размера (1-64 байт). Два последних варианта являются расширенным идентификатором, т.е. e(xtended)SPXI. Обычный идентификатор может использоваться лишь для "официальных" расширений, а расширенный для "официальных" и пользовательских. С расширением может быть ассоциировано вплоть до двух идентификаторов разного типа. Дескриптор расширения предназначен для обмена на этапе рукопожатия и имеет следующую структуру:

```text
B: byte(s)
b: bit(s)

|------------------------|
| Extension flag: 1b     |
|------------------------|
| eSPXI type or SPXI: 7b |
|------------------------|
| Extended SPXI: ~B      |
|------------------------|
```

- **Extension flag**: 0 если используется обычный SPXI, 1 если юзается eSPXI.
- **eSPXI type or SPXI**: если флаг 0, то простой идентификатор расширения (SPXI), если флаг 1, то тип расширенного идентификатора (eSPXI). Допустимые типы:
	- `0b0000001`: ASCII-строка оканчивающаяся нулём.
	- `0b0000010`: целое число произвольного размера.
- **Extended SPXI**:
	- Если флаг 0, то отсутствует.
	- Если тип eSPXI это строка, то строка, оканчивающаяся нулевым байтом.
	- Если тип eSPXI это число, то: `[1 byte: number size in bytes][>0 bytes: number]`
