# Сериализация и формат LBM

Данный формат сериализации используются в теле событий зарезервированных типов. Данные сериализованные в формат *LBM* (AKA "данные в формате *LBM*") являются расположенными последовательно ячейками с ключом, длинной значения и значением, в неопределённом порядке относительно друг-друга. Положение ячеек относительно друг-друга не детерминированно и они могут быть намеренно перемешаны. Отсутствие каких-либо ячеек вообще обозначается единичным нулевым байтом.

Ключ является однобайтным числом без знака. Ключ всегда больше нуля. В контексте протокола и событий зарезервированного типа, некоторые ключи имеют особое значение. Длинна значения является двухбайтным числом без знака. Если ячейка пуста, то длинна нулевая. Значением является произвольная последовательность байт.

Одна ячейка имеет следующий вид:

```text
B: byte(s)

|------------|
| Key: 1B    |
|------------|
| Length: 2B |
|------------|
| Value: ~B  |
|------------|
```

Пример в шестнадцатеричном представлении:

```text
  Length in bytes
    |
    VVVV
0xDA00080123456789ABCDEF
  ^^    ^^^^^^^^^^^^^^^^
  |     |
 Key   Value
```

Следовательно, форматированные данные целиком имеют вид:

```text
|------------|
| Cell 1: ~B |
|------------|
| Cell 2: ~B |
|------------|
| ...        |
|------------|
| Cell N: ~B |
|------------|
```

Пример в шестнадцатеричном представлении:

```text
                                          Cell #4 (1B)
                       Cell #2 (4B)         |
                        |                   |
                        VVVVVVVVVVVVVV      VVVVVVVV
0xDA00080123456789ABCDEFF10004FEDCBA98220000340001FF... (and so on)
  ^^^^^^^^^^^^^^^^^^^^^^              ^^^^^^
  |                                   |
 Cell #1 (8 bytes length)             |
                                     Cell #3 (empty cell)
```
